<?php
require_once(DIR_SYSTEM.'library/bitpay_func/sender.php');
class ControllerPaymentbitpay extends Controller {
	protected function index() {
		$this->language->load('payment/bitpay');
    	$this->data['button_confirm'] = $this->language->get('button_confirm');

		$this->data['text_wait'] = $this->language->get('text_wait');
		$this->data['text_ersal'] = $this->language->get('text_ersal');
		if (file_exists(DIR_TEMPLATE . $this->config->get('config_template') . '/template/payment/bitpay.tpl')) {
			$this->template = $this->config->get('config_template') . '/template/payment/bitpay.tpl';
		} else {
			$this->template = 'default/template/payment/bitpay.tpl';
		}

		$this->render();
}
public function confirm() {

		$this->load->model('checkout/order');

		$order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

		$this->load->library('encryption');

		$encryption = new Encryption($this->config->get('config_encryption'));

		//$this->data['Amount'] = $this->currency->format($order_info['total'], 'TMN', $order_info['value'], FALSE);


		$this->data['Amount'] = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);

		//$this->data['Amount']=$this->data['Amount']\10;


		$this->data['PIN']=$this->config->get('bitpay_PIN');


		$this->data['ResNum'] = $this->session->data['order_id'];

		$this->data['return'] = $this->url->link('checkout/success', '', 'SSL');
		//$this->data['return'] = HTTPS_SERVER . 'index.php?route=checkout/success';

		$this->data['cancel_return'] = $this->url->link('checkout/payment', '', 'SSL');
		//$this->data['cancel_return'] = HTTPS_SERVER . 'index.php?route=checkout/payment';

		$this->data['back'] = $this->url->link('checkout/payment', '', 'SSL');

        $url = 'https://bitpay.ir/payment/gateway-send';

		$amount = $this->data['Amount'];
		if($this->currency->getCode()!='RLS') {
		    $amount=$amount * 10;
	    }

        $this->data['order_id'] = $encryption->encrypt($this->session->data['order_id']);

		$callbackUrl  =  urlencode($this->url->link('payment/bitpay/callback', 'order_id=' . $this->data['order_id'], 'SSL'));

        $result = send($url,$this->data['PIN'],$amount,$callbackUrl);
        if($result < 0){
            $json = array();
	    	$json['error']= "Can not connect to bitpay.<br>";

		    $this->response->setOutput(json_encode($json));
        }


		if($result > 0 && is_numeric($result)){

		$this->data['action'] = "https://bitpay.ir/payment/gateway-$result";
		$json = array();
		$json['success']= $this->data['action'];

		$this->response->setOutput(json_encode($json));

		} else {

			$this->CheckState($res);
			//die();
		}

//



}

	public function CheckState($status) {
		$json = array();

	switch($status){

		case "-1" :
			$json['error']="api ارسالی با نوع api تعریف شده در bitpay سازگار نیست.";
			break;
		case "-2" :
			$json['error']="مقدار amount داده عددی نمی باشد.";
			break;
		case "-3" :
		 $json['error']="مقدار redirect رشته null است";
			break;
		case "-4" :
			$json['error']="درگاهی با اطلاعات ارسالی شما یافت نشده و یا در حالت انتظار می باشد.";
			break;
		default :
			$json['error']= "خطای نامشخص;";
			break;
	}


		$this->response->setOutput(json_encode($json));

}

function verify_payment($trans_id, $get_id){

    $this->data['PIN'] = $this->config->get('bitpay_PIN');
    $url = 'https://bitpay.ir/payment/gateway-result-second';
    $result = get($url,$this->data['PIN'],$trans_id,$get_id);
	$this->CheckState($result);

	if($result==1)
		return true;

	else {
		return false;
	}

	}


	public function callback() {
		$this->load->library('encryption');

		$encryption = new Encryption($this->config->get('config_encryption'));
        $trans_id = $_POST['trans_id'];
        $id_get = $_POST['id_get'];
		$order_id = $encryption->decrypt($this->request->get['order_id']);
		$MerchantID=$this->config->get('bitpay_PIN');
		$debugmod=false;

		$this->load->model('checkout/order');
		$order_info = $this->model_checkout_order->getOrder($order_id);


			$Amount = $this->currency->format($order_info['total'], $order_info['currency_code'], $order_info['currency_value'], false);		//echo $this->data['Amount'];
		$amount = $Amount/$order_info['currency_value'];

		if ($order_info) {
			if(($this->verify_payment($trans_id, $id_get)) or ($debugmod==true)) {
				$this->model_checkout_order->confirm($order_id, $this->config->get('bitpay_order_status_id'),'شماره رسيد ديجيتالي; Authority: '.$trans_id);

				$this->response->setOutput('<html><head><meta http-equiv="refresh" CONTENT="2; url=' . $this->url->link('checkout/success') . '"></head><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">با تشکر پرداخت تکمیل شد.لطفا چند لحظه صبر کنید و یا  <a href="' . $this->url->link('checkout/success') . '"><b>اینجا کلیک نمایید</b></a></td><td>&nbsp;</td></tr></table></body></html>');
			}else{
                $this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">.<br />خريد انجام نشد<br /><a href="' . $this->url->link('checkout/cart').  '"><b>بازگشت به فروشگاه</b></a></td><td>&nbsp;</td></tr></table></body></html>');
            }
		} else {
			$this->response->setOutput('<html><body><table border="0" width="100%"><tr><td>&nbsp;</td><td style="border: 1px solid gray; font-family: tahoma; font-size: 14px; direction: rtl; text-align: right;">.<br /><br /><a href="' . $this->url->link('checkout/cart').  '"><b>بازگشت به فروشگاه</b></a></td><td>&nbsp;</td></tr></table></body></html>');
		}
	}

}
?>